package org.me;

import java.util.List;

import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

import org.hamcrest.core.Every;

import static org.hamcrest.CoreMatchers.instanceOf;
import static org.hamcrest.CoreMatchers.is;

public class MainTest {

    /*
    MethodSource [className = 'org.me.MainTest', methodName = 'testEvery', methodParameterTypes = '']
    => java.lang.Error: Cannot determine correct type for matchesSafely() method.
       org.hamcrest.internal.ReflectiveTypeFinder.findExpectedType(ReflectiveTypeFinder.java:49)
       org.hamcrest.TypeSafeDiagnosingMatcher.<init>(TypeSafeDiagnosingMatcher.java:42)
       org.hamcrest.TypeSafeDiagnosingMatcher.<init>(TypeSafeDiagnosingMatcher.java:49)
       org.hamcrest.core.Every.<init>(Every.java:11)
       org.hamcrest.core.Every.everyItem(Every.java:45)
       org.me.MainTest.testEvery(MainTest.java:21)
       java.base@21.0.2/java.lang.reflect.Method.invoke(Method.java:580)
     */
    @Test
    public void testEvery() {
        List<Integer> numbers = List.of(1,1,1,1);
        Assert.assertThat(numbers, Every.everyItem(is(1)));
    }

    


    @Rule public ExpectedException expectedException = ExpectedException.none();

    /*
    MethodSource [className = 'org.me.MainTest', methodName = 'testExpectedException', methodParameterTypes = '']
    => java.lang.Error: Cannot determine correct type for matchesSafely() method.
       org.hamcrest.internal.ReflectiveTypeFinder.findExpectedType(ReflectiveTypeFinder.java:49)
       org.hamcrest.TypeSafeMatcher.<init>(TypeSafeMatcher.java:40)
       org.hamcrest.TypeSafeMatcher.<init>(TypeSafeMatcher.java:22)
    */
    @Test
    public void testExpectedException() {
        expectedException.expect(ArithmeticException.class);
        int res = 42 / 0;
    }

    /*
    MethodSource [className = 'org.me.MainTest', methodName = 'testExpectedExceptionCause', methodParameterTypes = '']
    => java.lang.Error: Cannot determine correct type for matchesSafely() method.
       org.hamcrest.internal.ReflectiveTypeFinder.findExpectedType(ReflectiveTypeFinder.java:49)
       org.hamcrest.TypeSafeMatcher.<init>(TypeSafeMatcher.java:40)
       org.hamcrest.TypeSafeMatcher.<init>(TypeSafeMatcher.java:22)
       org.junit.internal.matchers.ThrowableCauseMatcher.<init>(ThrowableCauseMatcher.java:19)
       org.junit.internal.matchers.ThrowableCauseMatcher.hasCause(ThrowableCauseMatcher.java:48)
       org.junit.rules.ExpectedException.expectCause(ExpectedException.java:237)
       org.me.MainTest.testExpectedExceptionCause(MainTest.java:61)
       java.base@21.0.2/java.lang.reflect.Method.invoke(Method.java:580)
    */
    @Test
    public void testExpectedExceptionCause() {
        expectedException.expectCause(instanceOf(ArithmeticException.class));
        try {
            int res = 42 / 0;
        } catch(ArithmeticException e) {
            throw new RuntimeException(e);
        }
    }
}
